diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/loop.c linux-2.4.22-ashuariadevel/drivers/block/loop.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/loop.c	2003-12-09 11:52:14.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/loop.c	2004-02-02 14:58:01.000000000 +0900
***************
*** 86,92 ****
  
  static int max_loop = 8;
  static struct loop_device *loop_dev;
! static int *loop_sizes;
  static int *loop_blksizes;
  static devfs_handle_t devfs_handle;      /*  For the directory */
  
--- 86,92 ----
  
  static int max_loop = 8;
  static struct loop_device *loop_dev;
! static sector_t *loop_sizes;
  static int *loop_blksizes;
  static devfs_handle_t devfs_handle;      /*  For the directory */
  
***************
*** 94,100 ****
   * Transfer functions
   */
  static int transfer_none(struct loop_device *lo, int cmd, char *raw_buf,
! 			 char *loop_buf, int size, int real_block)
  {
  	if (raw_buf != loop_buf) {
  		if (cmd == READ)
--- 94,100 ----
   * Transfer functions
   */
  static int transfer_none(struct loop_device *lo, int cmd, char *raw_buf,
! 			 char *loop_buf, int size, sector_t real_block)
  {
  	if (raw_buf != loop_buf) {
  		if (cmd == READ)
***************
*** 107,113 ****
  }
  
  static int transfer_xor(struct loop_device *lo, int cmd, char *raw_buf,
! 			char *loop_buf, int size, int real_block)
  {
  	char	*in, *out, *key;
  	int	i, keysize;
--- 107,113 ----
  }
  
  static int transfer_xor(struct loop_device *lo, int cmd, char *raw_buf,
! 			char *loop_buf, int size, sector_t real_block)
  {
  	char	*in, *out, *key;
  	int	i, keysize;
***************
*** 160,180 ****
  
  #define MAX_DISK_SIZE 1024*1024*1024
  
! static int compute_loop_size(struct loop_device *lo, struct dentry * lo_dentry, kdev_t lodev)
  {
! 	if (S_ISREG(lo_dentry->d_inode->i_mode))
! 		return (lo_dentry->d_inode->i_size - lo->lo_offset) >> BLOCK_SIZE_BITS;
! 	if (blk_size[MAJOR(lodev)])
! 		return blk_size[MAJOR(lodev)][MINOR(lodev)] -
!                                 (lo->lo_offset >> BLOCK_SIZE_BITS);
! 	return MAX_DISK_SIZE;
  }
  
! static void figure_loop_size(struct loop_device *lo)
  {
! 	loop_sizes[lo->lo_number] = compute_loop_size(lo,
! 					lo->lo_backing_file->f_dentry,
! 					lo->lo_device);
  }
  
  static int lo_send(struct loop_device *lo, struct buffer_head *bh, int bsize,
--- 160,208 ----
  
  #define MAX_DISK_SIZE 1024*1024*1024
  
! static sector_t compute_loop_size(struct loop_device *lo, struct dentry * lo_dentry, kdev_t lodev)
  {
+ 	/* Got this source from figure_loop_size(...) and need test. by Ashuaria
+ 	 * May have Huge bug. be careful */
+ 	loff_t size = lo->lo_backing_file->f_dentry->d_inode->i_mapping->host->i_size;
+ 	sector_t x;
+ 
+ 	/*
+ 	 * Unfortunately, if we want to do I/O on the device,
+ 	 * the number of 512-byte sectors has to fit into a sector_t.
+ 	 */
+ 	size = (size - lo->lo_offset) >> 9;
+ 	x = (sector_t)size;
+ 	if ((loff_t)x != size)
+ 		return -EFBIG;
! 	/*
! 	 * Convert sectors to blocks
! 	 */
! 	size >>= (BLOCK_SIZE_BITS - 9);
! 
! 	return (sector_t)size;
  }
  
! static int figure_loop_size(struct loop_device *lo)
  {
! 	loff_t size = lo->lo_backing_file->f_dentry->d_inode->i_mapping->host->i_size;
! 	sector_t x;
! 
! 	/*
! 	 * Unfortunately, if we want to do I/O on the device,
! 	 * the number of 512-byte sectors has to fit into a sector_t.
! 	 */
! 	size = (size - lo->lo_offset) >> 9;
! 	x = (sector_t)size;
! 	if ((loff_t)x != size)
! 		return -EFBIG;
! 	/*
! 	 * Convert sectors to blocks
! 	 */
! 	size >>= (BLOCK_SIZE_BITS - 9);
! 
! 	loop_sizes[lo->lo_number] = (sector_t)size;
! 	return 0;					
  }
  
  static int lo_send(struct loop_device *lo, struct buffer_head *bh, int bsize,
***************
*** 195,201 ****
  	len = bh->b_size;
  	data = bh->b_data;
  	while (len > 0) {
! 		int IV = index * (PAGE_CACHE_SIZE/bsize) + offset/bsize;
  		int transfer_result;
  
  		size = PAGE_CACHE_SIZE - offset;
--- 201,207 ----
  	len = bh->b_size;
  	data = bh->b_data;
  	while (len > 0) {
! 		sector_t IV = (sector_t)index * (PAGE_CACHE_SIZE/bsize) + offset/bsize;
  		int transfer_result;
  
  		size = PAGE_CACHE_SIZE - offset;
***************
*** 255,261 ****
  	unsigned long count = desc->count;
  	struct lo_read_data *p = (struct lo_read_data*)desc->buf;
  	struct loop_device *lo = p->lo;
! 	int IV = page->index * (PAGE_CACHE_SIZE/p->bsize) + offset/p->bsize;
  
  	if (size > count)
  		size = count;
--- 261,267 ----
  	unsigned long count = desc->count;
  	struct lo_read_data *p = (struct lo_read_data*)desc->buf;
  	struct loop_device *lo = p->lo;
! 	sector_t IV = (sector_t)page->index * (PAGE_CACHE_SIZE/p->bsize) + offset/p->bsize;
  
  	if (size > count)
  		size = count;
***************
*** 263,269 ****
  	kaddr = kmap(page);
  	if (lo_do_transfer(lo, READ, kaddr + offset, p->data, size, IV)) {
  		size = 0;
! 		printk(KERN_ERR "loop: transfer error block %ld\n",page->index);
  		desc->error = -EINVAL;
  	}
  	kunmap(page);
--- 269,275 ----
  	kaddr = kmap(page);
  	if (lo_do_transfer(lo, READ, kaddr + offset, p->data, size, IV)) {
  		size = 0;
! 		printk(KERN_ERR "loop: transfer error block %lu\n",page->index);
  		desc->error = -EINVAL;
  	}
  	kunmap(page);
***************
*** 321,335 ****
  	return bs;
  }
  
! static inline unsigned long loop_get_iv(struct loop_device *lo,
! 					unsigned long sector)
  {
  	int bs = loop_get_bs(lo);
  	unsigned long offset, IV;
  
! 	IV = sector / (bs >> 9) + lo->lo_offset / bs;
! 	offset = ((sector % (bs >> 9)) << 9) + lo->lo_offset % bs;
! 	if (offset >= bs)
  		IV++;
  
  	return IV;
--- 327,355 ----
  	return bs;
  }
  
! static inline int loop_get_bs_shift(struct loop_device *lo)
  {
  	int bs = loop_get_bs(lo);
+ 	int i;
+ 	/*
+ 	 * Assume power-of-two block size
+ 	 */
+ 	for (i = -1; bs; i++)
+ 		bs >>= 1;
+ 	return i;
+ }
+ 
+ static inline unsigned long loop_get_iv(struct loop_device *lo,
+ 					sector_t sector)
+ {
+ 	int bs = loop_get_bs_shift(lo);
  	unsigned long offset, IV;
  
! 	IV = (sector >> (bs - 9)) + (lo->lo_offset >> bs);
! 
! 	offset = ((sector & ((1 << (bs-9)) - 1))<<9) + (lo->lo_offset & ((1 << bs)-1));
! 
! 	if (offset >= (1 << bs))
  		IV++;
  
  	return IV;
***************
*** 571,577 ****
  		bh->b_end_io(bh, !ret);
  	} else {
  		struct buffer_head *rbh = bh->b_private;
! 		unsigned long IV = loop_get_iv(lo, rbh->b_rsector);
  
  		ret = lo_do_transfer(lo, READ, bh->b_data, rbh->b_data,
  				     bh->b_size, IV);
--- 591,597 ----
  		bh->b_end_io(bh, !ret);
  	} else {
  		struct buffer_head *rbh = bh->b_private;
! 		sector_t IV = loop_get_iv(lo, rbh->b_rsector);
  
  		ret = lo_do_transfer(lo, READ, bh->b_data, rbh->b_data,
  				     bh->b_size, IV);
***************
*** 717,723 ****
                 lo->lo_change = NULL;
                 lo->transfer = NULL;
                 lo->ioctl = NULL;
!                figure_loop_size(lo);
                 lo->old_gfp_mask = inode->i_mapping->gfp_mask;
                 inode->i_mapping->gfp_mask &= ~(__GFP_IO|__GFP_FS);
  
--- 737,747 ----
                 lo->lo_change = NULL;
                 lo->transfer = NULL;
                 lo->ioctl = NULL;
!                if (figure_loop_size(lo)) {
!                        error = -EFBIG;
!                        fput(file);
!                        goto out_putf;
!                }
                 lo->old_gfp_mask = inode->i_mapping->gfp_mask;
                 inode->i_mapping->gfp_mask &= ~(__GFP_IO|__GFP_FS);
  
***************
*** 860,865 ****
--- 884,890 ----
  {
  	struct loop_info info; 
  	int err;
+ 	loff_t offset;
  	unsigned int type;
  
  	if (lo->lo_encrypt_key_size && lo->lo_key_owner != current->uid && 
***************
*** 879,888 ****
  	err = loop_release_xfer(lo);
  	if (!err) 
  		err = loop_init_xfer(lo, type, &info);
  	if (err)
  		return err;	
  
- 	lo->lo_offset = info.lo_offset;
  	strncpy(lo->lo_name, info.lo_name, LO_NAME_SIZE);
  
  	lo->transfer = xfer_funcs[type]->transfer;
--- 904,921 ----
  	err = loop_release_xfer(lo);
  	if (!err) 
  		err = loop_init_xfer(lo, type, &info);
+ 
+ 	offset = lo->lo_offset;
+ 	if (offset != info.lo_offset) {
+ 		lo->lo_offset = info.lo_offset;
+ 		if (figure_loop_size(lo)){
+ 			err = -EFBIG;
+ 			lo->lo_offset = offset;
+ 		}
+ 	}
  	if (err)
  		return err;	
  
  	strncpy(lo->lo_name, info.lo_name, LO_NAME_SIZE);
  
  	lo->transfer = xfer_funcs[type]->transfer;
***************
*** 960,971 ****
  		err = loop_get_status(lo, (struct loop_info *) arg);
  		break;
  	case BLKGETSIZE:
  		if (lo->lo_state != Lo_bound) {
  			err = -ENXIO;
  			break;
  		}
! 		err = put_user((unsigned long)loop_sizes[lo->lo_number] << 1, (unsigned long *) arg);
  		break;
  	case BLKGETSIZE64:
  		if (lo->lo_state != Lo_bound) {
  			err = -ENXIO;
--- 993,1011 ----
  		err = loop_get_status(lo, (struct loop_info *) arg);
  		break;
  	case BLKGETSIZE:
+ 	{
+ 		unsigned long val;
  		if (lo->lo_state != Lo_bound) {
  			err = -ENXIO;
  			break;
  		}
! 		val = loop_sizes[lo->lo_number] << 1;
! 		if ((sector_t) val != (loop_sizes[lo->lo_number] << 1))
! 			err = -EFBIG;
! 		else
! 			err = put_user(val, (unsigned long *) arg);
  		break;
+ 	}
  	case BLKGETSIZE64:
  		if (lo->lo_state != Lo_bound) {
  			err = -ENXIO;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/nbd.c linux-2.4.22-ashuariadevel/drivers/block/nbd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/nbd.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/nbd.c	2004-02-02 14:35:08.000000000 +0900
***************
*** 59,65 ****
  
  static int nbd_blksizes[MAX_NBD];
  static int nbd_blksize_bits[MAX_NBD];
! static int nbd_sizes[MAX_NBD];
  static u64 nbd_bytesizes[MAX_NBD];
  
  static struct nbd_device nbd_dev[MAX_NBD];
--- 59,65 ----
  
  static int nbd_blksizes[MAX_NBD];
  static int nbd_blksize_bits[MAX_NBD];
! static sector_t nbd_sizes[MAX_NBD];
  static u64 nbd_bytesizes[MAX_NBD];
  
  static struct nbd_device nbd_dev[MAX_NBD];
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/paride/pd.c linux-2.4.22-ashuariadevel/drivers/block/paride/pd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/paride/pd.c	2002-11-29 08:53:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/paride/pd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 286,292 ****
  static void pd_eject( int unit);
  
  static struct hd_struct pd_hd[PD_DEVS];
! static int pd_sizes[PD_DEVS];
  static int pd_blocksizes[PD_DEVS];
  static int pd_maxsectors[PD_DEVS];
  
--- 286,292 ----
  static void pd_eject( int unit);
  
  static struct hd_struct pd_hd[PD_DEVS];
! static sector_t pd_sizes[PD_DEVS];
  static int pd_blocksizes[PD_DEVS];
  static int pd_maxsectors[PD_DEVS];
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/ps2esdi.c linux-2.4.22-ashuariadevel/drivers/block/ps2esdi.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/ps2esdi.c	2002-11-29 08:53:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/ps2esdi.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 116,122 ****
  static int no_int_yet;
  static int access_count[MAX_HD];
  static char ps2esdi_valid[MAX_HD];
! static int ps2esdi_sizes[MAX_HD << 6];
  static int ps2esdi_blocksizes[MAX_HD << 6];
  static int ps2esdi_maxsect[MAX_HD << 6];
  static int ps2esdi_drives;
--- 116,122 ----
  static int no_int_yet;
  static int access_count[MAX_HD];
  static char ps2esdi_valid[MAX_HD];
! static sector_t ps2esdi_sizes[MAX_HD << 6];
  static int ps2esdi_blocksizes[MAX_HD << 6];
  static int ps2esdi_maxsect[MAX_HD << 6];
  static int ps2esdi_drives;
***************
*** 517,523 ****
  	/* is request is valid */ 
  	else {
  		printk("Grrr. error. ps2esdi_drives: %d, %lu %lu\n", ps2esdi_drives,
! 		       CURRENT->sector, ps2esdi[MINOR(CURRENT->rq_dev)].nr_sects);
  		end_request(FAIL);
  	}
  
--- 517,523 ----
  	/* is request is valid */ 
  	else {
  		printk("Grrr. error. ps2esdi_drives: %d, %lu %lu\n", ps2esdi_drives,
! 		       (unsigned long)CURRENT->sector, (unsigned long)ps2esdi[MINOR(CURRENT->rq_dev)].nr_sects);
  		end_request(FAIL);
  	}
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/rd.c linux-2.4.22-ashuariadevel/drivers/block/rd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/rd.c	2002-11-29 08:53:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/rd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 75,81 ****
  static unsigned long rd_length[NUM_RAMDISKS];	/* Size of RAM disks in bytes   */
  static int rd_hardsec[NUM_RAMDISKS];		/* Size of real blocks in bytes */
  static int rd_blocksizes[NUM_RAMDISKS];		/* Size of 1024 byte blocks :)  */
! static int rd_kbsize[NUM_RAMDISKS];		/* Size in blocks of 1024 bytes */
  static devfs_handle_t devfs_handle;
  static struct block_device *rd_bdev[NUM_RAMDISKS];/* Protected device data */
  
--- 75,81 ----
  static unsigned long rd_length[NUM_RAMDISKS];	/* Size of RAM disks in bytes   */
  static int rd_hardsec[NUM_RAMDISKS];		/* Size of real blocks in bytes */
  static int rd_blocksizes[NUM_RAMDISKS];		/* Size of 1024 byte blocks :)  */
! static sector_t rd_kbsize[NUM_RAMDISKS];		/* Size in blocks of 1024 bytes */
  static devfs_handle_t devfs_handle;
  static struct block_device *rd_bdev[NUM_RAMDISKS];/* Protected device data */
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/umem.c linux-2.4.22-ashuariadevel/drivers/block/umem.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/umem.c	2003-06-13 23:51:32.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/umem.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 161,167 ****
  
  static int              mm_hardsect  [MM_MAXCARDS << MM_SHIFT];
  static int              mm_blocksizes[MM_MAXCARDS << MM_SHIFT];
! static int              mm_sizes[MM_MAXCARDS << MM_SHIFT];
  static struct hd_struct mm_partitions[MM_MAXCARDS << MM_SHIFT];
  
  static int num_cards = 0;
--- 161,167 ----
  
  static int              mm_hardsect  [MM_MAXCARDS << MM_SHIFT];
  static int              mm_blocksizes[MM_MAXCARDS << MM_SHIFT];
! static sector_t         mm_sizes[MM_MAXCARDS << MM_SHIFT];
  static struct hd_struct mm_partitions[MM_MAXCARDS << MM_SHIFT];
  
  static int num_cards = 0;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/block/xd.c linux-2.4.22-ashuariadevel/drivers/block/xd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/block/xd.c	2002-11-29 08:53:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/block/xd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 121,127 ****
  };
  
  static struct hd_struct xd_struct[XD_MAXDRIVES << 6];
! static int xd_sizes[XD_MAXDRIVES << 6], xd_access[XD_MAXDRIVES];
  static int xd_blocksizes[XD_MAXDRIVES << 6];
  static int xd_maxsect[XD_MAXDRIVES << 6];
  
--- 121,127 ----
  };
  
  static struct hd_struct xd_struct[XD_MAXDRIVES << 6];
! static sector_t xd_sizes[XD_MAXDRIVES << 6], xd_access[XD_MAXDRIVES];
  static int xd_blocksizes[XD_MAXDRIVES << 6];
  static int xd_maxsect[XD_MAXDRIVES << 6];
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/char/raw.c linux-2.4.22-ashuariadevel/drivers/char/raw.c
*** linux-2.4.22-ashuariadevel.backup/drivers/char/raw.c	2003-12-09 11:52:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/char/raw.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 287,293 ****
  {
  	struct kiobuf * iobuf;
  	int		err = 0;
! 	unsigned long	blocknr, blocks;
  	size_t		transferred;
  	int		iosize;
  	int		i;
--- 287,294 ----
  {
  	struct kiobuf * iobuf;
  	int		err = 0;
! 	sector_t	blocknr;
! 	unsigned long	blocks;
  	size_t		transferred;
  	int		iosize;
  	int		i;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-cd.c linux-2.4.22-ashuariadevel/drivers/ide/ide-cd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-cd.c	2003-12-09 11:52:14.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-cd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1211,1218 ****
  	   paranoid and check. */
  	if (rq->current_nr_sectors < (rq->bh->b_size >> SECTOR_BITS) &&
  	    (rq->sector % SECTORS_PER_FRAME) != 0) {
! 		printk("%s: cdrom_read_from_buffer: buffer botch (%ld)\n",
! 			drive->name, rq->sector);
  		cdrom_end_request(drive, 0);
  		return -1;
  	}
--- 1211,1218 ----
  	   paranoid and check. */
  	if (rq->current_nr_sectors < (rq->bh->b_size >> SECTOR_BITS) &&
  	    (rq->sector % SECTORS_PER_FRAME) != 0) {
! 		printk("%s: cdrom_read_from_buffer: buffer botch (%llu)\n",
! 			drive->name, (unsigned long long)rq->sector);
  		cdrom_end_request(drive, 0);
  		return -1;
  	}
***************
*** 1848,1855 ****
   * cdrom driver request routine.
   */
  static ide_startstop_t
! ide_do_rw_cdrom (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	ide_startstop_t action;
  	struct cdrom_info *info = drive->driver_data;
  
--- 1848,1856 ----
   * cdrom driver request routine.
   */
  static ide_startstop_t
! ide_do_rw_cdrom (ide_drive_t *drive, struct request *rq, sector_t sect)
  {
+ 	unsigned long block = (unsigned long)sect;
  	ide_startstop_t action;
  	struct cdrom_info *info = drive->driver_data;
  
***************
*** 3089,3102 ****
  }
  
  static
! unsigned long ide_cdrom_capacity (ide_drive_t *drive)
  {
  	unsigned long capacity;
  
  	if (cdrom_read_capacity(drive, &capacity, NULL))
  		return 0;
  
! 	return capacity * SECTORS_PER_FRAME;
  }
  
  static
--- 3090,3103 ----
  }
  
  static
! sector_t ide_cdrom_capacity (ide_drive_t *drive)
  {
  	unsigned long capacity;
  
  	if (cdrom_read_capacity(drive, &capacity, NULL))
  		return 0;
  
! 	return (sector_t)capacity * SECTORS_PER_FRAME;
  }
  
  static
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-disk.c linux-2.4.22-ashuariadevel/drivers/ide/ide-disk.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-disk.c	2003-12-09 11:52:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-disk.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 360,366 ****
   * It also takes care of issuing special DRIVE_CMDs.
   */
  
! ide_startstop_t __ide_do_rw_disk (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	ide_hwif_t *hwif	= HWIF(drive);
  	u8 lba48		= (drive->addressing == 1) ? 1 : 0;
--- 360,366 ----
   * It also takes care of issuing special DRIVE_CMDs.
   */
  
! ide_startstop_t __ide_do_rw_disk (ide_drive_t *drive, struct request *rq, sector_t block)
  {
  	ide_hwif_t *hwif	= HWIF(drive);
  	u8 lba48		= (drive->addressing == 1) ? 1 : 0;
***************
*** 387,396 ****
  			tasklets[5] = (task_ioreg_t) (block>>8);
  			tasklets[6] = (task_ioreg_t) (block>>16);
  			tasklets[7] = (task_ioreg_t) (block>>24);
  			tasklets[8] = (task_ioreg_t) 0;
  			tasklets[9] = (task_ioreg_t) 0;
! //			tasklets[8] = (task_ioreg_t) (block>>32);
! //			tasklets[9] = (task_ioreg_t) (block>>40);
  #ifdef DEBUG
  			printk("%s: %sing: LBAsect=%lu, sectors=%ld, "
  				"buffer=0x%08lx, LBAsect=0x%012lx\n",
--- 387,399 ----
  			tasklets[5] = (task_ioreg_t) (block>>8);
  			tasklets[6] = (task_ioreg_t) (block>>16);
  			tasklets[7] = (task_ioreg_t) (block>>24);
+ #if CONFIG_LBD
+ 			tasklets[8] = (task_ioreg_t) (block>>32);
+ 			tasklets[9] = (task_ioreg_t) (block>>40);
+ #else
  			tasklets[8] = (task_ioreg_t) 0;
  			tasklets[9] = (task_ioreg_t) 0;
! #endif
  #ifdef DEBUG
  			printk("%s: %sing: LBAsect=%lu, sectors=%ld, "
  				"buffer=0x%08lx, LBAsect=0x%012lx\n",
***************
*** 434,441 ****
  		}
  	} else {
  		unsigned int sect,head,cyl,track;
! 		track = block / drive->sect;
! 		sect  = block % drive->sect + 1;
  		hwif->OUTB(sect, IDE_SECTOR_REG);
  		head  = track % drive->head;
  		cyl   = track / drive->head;
--- 437,444 ----
  		}
  	} else {
  		unsigned int sect,head,cyl,track;
! 		track = (unsigned int)block / drive->sect;
! 		sect  = (unsigned int)block % drive->sect + 1;
  		hwif->OUTB(sect, IDE_SECTOR_REG);
  		head  = track % drive->head;
  		cyl   = track / drive->head;
***************
*** 695,701 ****
  
  #endif /* CONFIG_IDE_TASKFILE_IO */
  
! static ide_startstop_t ide_do_rw_disk (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	ide_hwif_t *hwif	= HWIF(drive);
  	if (hwif->rw_disk)
--- 698,704 ----
  
  #endif /* CONFIG_IDE_TASKFILE_IO */
  
! static ide_startstop_t ide_do_rw_disk (ide_drive_t *drive, struct request *rq, sector_t block)
  {
  	ide_hwif_t *hwif	= HWIF(drive);
  	if (hwif->rw_disk)
***************
*** 879,886 ****
  				}
  			}
  			if (HWGROUP(drive) && HWGROUP(drive)->rq)
! 				printk(", sector=%ld",
! 					HWGROUP(drive)->rq->sector);
  		}
  	}
  #endif	/* FANCY_STATUS_DUMPS */
--- 882,889 ----
  				}
  			}
  			if (HWGROUP(drive) && HWGROUP(drive)->rq)
! 				printk(", sector=%llu",
! 				       (unsigned long long)HWGROUP(drive)->rq->sector);
  		}
  	}
  #endif	/* FANCY_STATUS_DUMPS */
***************
*** 1233,1239 ****
  	}
  }
  
! static unsigned long idedisk_capacity (ide_drive_t *drive)
  {
  	if (drive->id->cfs_enable_2 & 0x0400)
  		return (drive->capacity48 - drive->sect0);
--- 1236,1242 ----
  	}
  }
  
! static sector_t idedisk_capacity (ide_drive_t *drive)
  {
  	if (drive->id->cfs_enable_2 & 0x0400)
  		return (drive->capacity48 - drive->sect0);
***************
*** 1682,1698 ****
  
  	/*
  	 * if possible, give fdisk access to more of the drive,
! 	 * by correcting bios_cyls:
  	 */
  	capacity = idedisk_capacity (drive);
! 	if ((capacity >= (drive->bios_cyl * drive->bios_sect * drive->bios_head)) &&
! 	    (!drive->forced_geom) && drive->bios_sect && drive->bios_head)
! 		drive->bios_cyl = (capacity / drive->bios_sect) / drive->bios_head;
! 	printk (KERN_INFO "%s: %ld sectors", drive->name, capacity);
  
  	/* Give size in megabytes (MB), not mebibytes (MiB). */
  	/* We compute the exact rounded value, avoiding overflow. */
! 	printk (" (%ld MB)", (capacity - capacity/625 + 974)/1950);
  
  	/* Only print cache size when it was specified */
  	if (id->buf_size)
--- 1685,1712 ----
  
  	/*
  	 * if possible, give fdisk access to more of the drive,
!  	 * by correcting bios_cyls:
  	 */
  	capacity = idedisk_capacity (drive);
! 	if ((capacity > (((sector_t)drive->bios_cyl * drive->bios_sect * drive->bios_head))) &&
! 	    (!drive->forced_geom) && drive->bios_sect && drive->bios_head) {
! 		sector_t cyl = capacity;
! 		sector_div(cyl, drive->bios_head * drive->bios_sect);
! 		if (cyl > 0x7fffffffULL)
! 			drive->bios_cyl = 0x7fffffffUL;
! 		else
! 			drive->bios_cyl = cyl;
! 	}
  
  	/* Give size in megabytes (MB), not mebibytes (MiB). */
  	/* We compute the exact rounded value, avoiding overflow. */
! 	{
! 		sector_t mbcap = capacity;
! 		sector_div(mbcap, 625);
! 		mbcap = capacity - mbcap + 974;
! 		sector_div(mbcap, 1950);
! 		printk (" (%llu MB)", (unsigned long long)mbcap);
! 	}
  
  	/* Only print cache size when it was specified */
  	if (id->buf_size)
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-floppy.c linux-2.4.22-ashuariadevel/drivers/ide/ide-floppy.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-floppy.c	2003-08-25 20:44:41.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-floppy.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1262,1278 ****
  /*
   *	idefloppy_do_request is our request handling function.	
   */
! static ide_startstop_t idefloppy_do_request (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	idefloppy_floppy_t *floppy = drive->driver_data;
  	idefloppy_pc_t *pc;
  
  #if IDEFLOPPY_DEBUG_LOG
  	printk(KERN_INFO "rq_status: %d, rq_dev: %u, cmd: %d, errors: %d\n",
  		rq->rq_status, (unsigned int) rq->rq_dev, rq->cmd, rq->errors);
! 	printk(KERN_INFO "sector: %ld, nr_sectors: %ld, "
! 			"current_nr_sectors: %ld\n", rq->sector,
  			rq->nr_sectors, rq->current_nr_sectors);
  #endif /* IDEFLOPPY_DEBUG_LOG */
  
  	if (rq->errors >= ERROR_MAX) {
--- 1262,1280 ----
  /*
   *	idefloppy_do_request is our request handling function.	
   */
! static ide_startstop_t idefloppy_do_request (ide_drive_t *drive, struct request *rq, sector_t sect)
  {
  	idefloppy_floppy_t *floppy = drive->driver_data;
  	idefloppy_pc_t *pc;
+ 	unsigned long block = (unsigned long)sect;
  
  #if IDEFLOPPY_DEBUG_LOG
  	printk(KERN_INFO "rq_status: %d, rq_dev: %u, cmd: %d, errors: %d\n",
  		rq->rq_status, (unsigned int) rq->rq_dev, rq->cmd, rq->errors);
! 	printk(KERN_INFO "sector: %llu, nr_sectors: %ld, "
! 	       "current_nr_sectors: %ld\n", (unsigned long long)rq->sector,
  			rq->nr_sectors, rq->current_nr_sectors);
+ 	printk (KERN_INFO "sector: %llu, nr_sectors: %ld, current_nr_sectors: %ld\n",(unsigned long long)rq->sector,rq->nr_sectors,rq->current_nr_sectors);
  #endif /* IDEFLOPPY_DEBUG_LOG */
  
  	if (rq->errors >= ERROR_MAX) {
***************
*** 1290,1296 ****
  	switch (rq->cmd) {
  		case READ:
  		case WRITE:
! 			if (rq->sector % floppy->bs_factor ||
  			    rq->nr_sectors % floppy->bs_factor) {
  				printk("%s: unsupported r/w request size\n",
  					drive->name);
--- 1292,1298 ----
  	switch (rq->cmd) {
  		case READ:
  		case WRITE:
! 			if (block % floppy->bs_factor ||
  			    rq->nr_sectors % floppy->bs_factor) {
  				printk("%s: unsupported r/w request size\n",
  					drive->name);
***************
*** 1846,1857 ****
  /*
   *	Return the current floppy capacity to ide.c.
   */
! static unsigned long idefloppy_capacity (ide_drive_t *drive)
  {
  	idefloppy_floppy_t *floppy = drive->driver_data;
  	unsigned long capacity = floppy->blocks * floppy->bs_factor;
  
! 	return capacity;
  }
  
  /*
--- 1848,1859 ----
  /*
   *	Return the current floppy capacity to ide.c.
   */
! static sector_t idefloppy_capacity (ide_drive_t *drive)
  {
  	idefloppy_floppy_t *floppy = drive->driver_data;
  	unsigned long capacity = floppy->blocks * floppy->bs_factor;
  
! 	return (sector_t)capacity;
  }
  
  /*
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-probe.c linux-2.4.22-ashuariadevel/drivers/ide/ide-probe.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-probe.c	2003-12-09 11:52:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-probe.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1179,1185 ****
  		goto err_kmalloc_gd;
  	memset(gd, 0, sizeof(struct gendisk));
  	
! 	gd->sizes = kmalloc(minors * sizeof(int), GFP_KERNEL);
  	if (!gd->sizes)
  		goto err_kmalloc_gd_sizes;
  	gd->part  = kmalloc(minors * sizeof(struct hd_struct), GFP_KERNEL);
--- 1179,1185 ----
  		goto err_kmalloc_gd;
  	memset(gd, 0, sizeof(struct gendisk));
  	
! 	gd->sizes = kmalloc (minors * sizeof(gd->sizes[0]), GFP_KERNEL);
  	if (!gd->sizes)
  		goto err_kmalloc_gd_sizes;
  	gd->part  = kmalloc(minors * sizeof(struct hd_struct), GFP_KERNEL);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-tape.c linux-2.4.22-ashuariadevel/drivers/ide/ide-tape.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-tape.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-tape.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2783,2789 ****
  /*
   *	idetape_do_request is our request handling function.	
   */
! static ide_startstop_t idetape_do_request (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	idetape_tape_t *tape = drive->driver_data;
  	idetape_pc_t *pc;
--- 2783,2789 ----
  /*
   *	idetape_do_request is our request handling function.	
   */
! static ide_startstop_t idetape_do_request (ide_drive_t *drive, struct request *rq, sector_t block)
  {
  	idetape_tape_t *tape = drive->driver_data;
  	idetape_pc_t *pc;
***************
*** 2796,2804 ****
  			"rq_dev: %u, cmd: %d, errors: %d\n", rq->rq_status,
  			(unsigned int) rq->rq_dev, rq->cmd, rq->errors);
  	if (tape->debug_level >= 2)
! 		printk(KERN_INFO "ide-tape: sector: %ld, "
  			"nr_sectors: %ld, current_nr_sectors: %ld\n",
! 			rq->sector, rq->nr_sectors, rq->current_nr_sectors);
  #endif /* IDETAPE_DEBUG_LOG */
  
  	if (!IDETAPE_RQ_CMD(rq->cmd)) {
--- 2796,2805 ----
  			"rq_dev: %u, cmd: %d, errors: %d\n", rq->rq_status,
  			(unsigned int) rq->rq_dev, rq->cmd, rq->errors);
  	if (tape->debug_level >= 2)
! 		printk(KERN_INFO "ide-tape: sector: %llu, "
  			"nr_sectors: %ld, current_nr_sectors: %ld\n",
! 			(unsigned long long)rq->sector,rq->nr_sectors,
! 			rq->current_nr_sectors);
  #endif /* IDETAPE_DEBUG_LOG */
  
  	if (!IDETAPE_RQ_CMD(rq->cmd)) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-taskfile.c linux-2.4.22-ashuariadevel/drivers/ide/ide-taskfile.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide-taskfile.c	2003-06-13 23:51:33.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide-taskfile.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 329,336 ****
  				}
  			}
  			if (HWGROUP(drive)->rq)
! 				printk(", sector=%lu",
! 					HWGROUP(drive)->rq->sector);
  		}
  media_out:
  #endif  /* FANCY_STATUS_DUMPS */
--- 329,336 ----
  				}
  			}
  			if (HWGROUP(drive)->rq)
! 				printk(", sector=%llu",
! 				       (unsigned long long)HWGROUP(drive)->rq->sector);
  		}
  media_out:
  #endif  /* FANCY_STATUS_DUMPS */
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/ide.c linux-2.4.22-ashuariadevel/drivers/ide/ide.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/ide.c	2003-12-09 11:52:12.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/ide.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 431,437 ****
  					}
  				}
  				if (HWGROUP(drive) && HWGROUP(drive)->rq)
! 					printk(", sector=%ld", HWGROUP(drive)->rq->sector);
  			}
  		}
  #endif	/* FANCY_STATUS_DUMPS */
--- 431,438 ----
  					}
  				}
  				if (HWGROUP(drive) && HWGROUP(drive)->rq)
! 					printk(", sector=%llu", 
! 					       (unsigned long long)HWGROUP(drive)->rq->sector);
  			}
  		}
  #endif	/* FANCY_STATUS_DUMPS */
***************
*** 2693,2699 ****
  	return 0;
  }
  
! static ide_startstop_t default_do_request (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  	ide_end_request(drive, 0);
  	return ide_stopped;
--- 2694,2700 ----
  	return 0;
  }
  
! static ide_startstop_t default_do_request(ide_drive_t *drive, struct request *rq, sector_t block)
  {
  	ide_end_request(drive, 0);
  	return ide_stopped;
***************
*** 2744,2752 ****
  {
  }
  
! static unsigned long default_capacity (ide_drive_t *drive)
  {
! 	return 0x7fffffff;
  }
  
  static ide_startstop_t default_special (ide_drive_t *drive)
--- 2745,2753 ----
  {
  }
  
! static sector_t default_capacity (ide_drive_t *drive)
  {
! 	return (sector_t)0x7fffffff;
  }
  
  static ide_startstop_t default_special (ide_drive_t *drive)
